// $ANTLR 2.7.7 (20080607): "vinl_grammar.g" -> "VinlParser.java"$

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.collections.AST;
import java.util.Hashtable;
import antlr.ASTFactory;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;

/***************************************************************
 *  parser
 ***************************************************************/
public class VinlParser extends antlr.LLkParser       implements VinlAntlrTokenTypes
 {

protected VinlParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public VinlParser(TokenBuffer tokenBuf) {
  this(tokenBuf,2);
}

protected VinlParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public VinlParser(TokenStream lexer) {
  this(lexer,2);
}

public VinlParser(ParserSharedInputState state) {
  super(state,2);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

	public final void cmd() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST cmd_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LPAREN:
			case LBRACE:
			case ID:
			case DECIMAL:
			case LITERAL_if:
			case LITERAL_while:
			case LITERAL_for:
			case LITERAL_break:
			case LITERAL_continue:
			case LITERAL_return:
			case LITERAL_pendown:
			case LITERAL_pd:
			case LITERAL_penup:
			case LITERAL_pu:
			case LITERAL_home:
			case LITERAL_forward:
			case LITERAL_fw:
			case LITERAL_backward:
			case LITERAL_bw:
			case LITERAL_right:
			case LITERAL_rt:
			case LITERAL_left:
			case LITERAL_lf:
			case LITERAL_echo:
			case LITERAL_clear:
			case LITERAL_cl:
			case LITERAL_status:
			case LITERAL_void:
			case LITERAL_funct:
			case LITERAL_true:
			case LITERAL_false:
			case LITERAL_var:
			{
				{
				switch ( LA(1)) {
				case LPAREN:
				case LBRACE:
				case ID:
				case DECIMAL:
				case LITERAL_if:
				case LITERAL_while:
				case LITERAL_for:
				case LITERAL_break:
				case LITERAL_continue:
				case LITERAL_return:
				case LITERAL_pendown:
				case LITERAL_pd:
				case LITERAL_penup:
				case LITERAL_pu:
				case LITERAL_home:
				case LITERAL_forward:
				case LITERAL_fw:
				case LITERAL_backward:
				case LITERAL_bw:
				case LITERAL_right:
				case LITERAL_rt:
				case LITERAL_left:
				case LITERAL_lf:
				case LITERAL_echo:
				case LITERAL_clear:
				case LITERAL_cl:
				case LITERAL_status:
				case LITERAL_void:
				case LITERAL_true:
				case LITERAL_false:
				case LITERAL_var:
				{
					statement();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case LITERAL_funct:
				{
					func_def();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				cmd_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_exit:
			case LITERAL_bye:
			case LITERAL_quit:
			{
				{
				switch ( LA(1)) {
				case LITERAL_exit:
				{
					AST tmp1_AST = null;
					tmp1_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp1_AST);
					match(LITERAL_exit);
					break;
				}
				case LITERAL_bye:
				{
					AST tmp2_AST = null;
					tmp2_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp2_AST);
					match(LITERAL_bye);
					break;
				}
				case LITERAL_quit:
				{
					AST tmp3_AST = null;
					tmp3_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp3_AST);
					match(LITERAL_quit);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				System.exit(0);
				cmd_AST = (AST)currentAST.root;
				break;
			}
			case EOF:
			{
				match(Token.EOF_TYPE);
				System.exit(0);
				cmd_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_0);
		}
		returnAST = cmd_AST;
	}
	
	public final void statement() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST statement_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LITERAL_if:
			{
				selection_stmt();
				astFactory.addASTChild(currentAST, returnAST);
				statement_AST = (AST)currentAST.root;
				break;
			}
			case LPAREN:
			case ID:
			case DECIMAL:
			case LITERAL_void:
			case LITERAL_true:
			case LITERAL_false:
			case LITERAL_var:
			{
				expression_stmt();
				astFactory.addASTChild(currentAST, returnAST);
				statement_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_while:
			case LITERAL_for:
			{
				iteration_stmt();
				astFactory.addASTChild(currentAST, returnAST);
				statement_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_break:
			case LITERAL_continue:
			case LITERAL_return:
			case LITERAL_pendown:
			case LITERAL_pd:
			case LITERAL_penup:
			case LITERAL_pu:
			case LITERAL_home:
			case LITERAL_forward:
			case LITERAL_fw:
			case LITERAL_backward:
			case LITERAL_bw:
			case LITERAL_right:
			case LITERAL_rt:
			case LITERAL_left:
			case LITERAL_lf:
			case LITERAL_echo:
			case LITERAL_clear:
			case LITERAL_cl:
			case LITERAL_status:
			{
				keyword_stmt();
				astFactory.addASTChild(currentAST, returnAST);
				statement_AST = (AST)currentAST.root;
				break;
			}
			case LBRACE:
			{
				match(LBRACE);
				{
				_loop52:
				do {
					if ((_tokenSet_1.member(LA(1)))) {
						statement();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						break _loop52;
					}
					
				} while (true);
				}
				match(RBRACE);
				statement_AST = (AST)currentAST.root;
				statement_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(STATEMENT,"STATEMENT")).add(statement_AST));
				currentAST.root = statement_AST;
				currentAST.child = statement_AST!=null &&statement_AST.getFirstChild()!=null ?
					statement_AST.getFirstChild() : statement_AST;
				currentAST.advanceChildToEnd();
				statement_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_2);
		}
		returnAST = statement_AST;
	}
	
	public final void func_def() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST func_def_AST = null;
		
		try {      // for error handling
			AST tmp7_AST = null;
			tmp7_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp7_AST);
			match(LITERAL_funct);
			AST tmp8_AST = null;
			tmp8_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp8_AST);
			match(ID);
			match(LPAREN);
			params_list();
			astFactory.addASTChild(currentAST, returnAST);
			match(RPAREN);
			func_body();
			astFactory.addASTChild(currentAST, returnAST);
			func_def_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_3);
		}
		returnAST = func_def_AST;
	}
	
	public final void program() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST program_AST = null;
		
		try {      // for error handling
			{
			_loop49:
			do {
				switch ( LA(1)) {
				case LPAREN:
				case LBRACE:
				case ID:
				case DECIMAL:
				case LITERAL_if:
				case LITERAL_while:
				case LITERAL_for:
				case LITERAL_break:
				case LITERAL_continue:
				case LITERAL_return:
				case LITERAL_pendown:
				case LITERAL_pd:
				case LITERAL_penup:
				case LITERAL_pu:
				case LITERAL_home:
				case LITERAL_forward:
				case LITERAL_fw:
				case LITERAL_backward:
				case LITERAL_bw:
				case LITERAL_right:
				case LITERAL_rt:
				case LITERAL_left:
				case LITERAL_lf:
				case LITERAL_echo:
				case LITERAL_clear:
				case LITERAL_cl:
				case LITERAL_status:
				case LITERAL_void:
				case LITERAL_true:
				case LITERAL_false:
				case LITERAL_var:
				{
					statement();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case LITERAL_funct:
				{
					func_def();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				default:
				{
					break _loop49;
				}
				}
			} while (true);
			}
			match(Token.EOF_TYPE);
			program_AST = (AST)currentAST.root;
			program_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(STATEMENT,"PROGRAM")).add(program_AST));
			currentAST.root = program_AST;
			currentAST.child = program_AST!=null &&program_AST.getFirstChild()!=null ?
				program_AST.getFirstChild() : program_AST;
			currentAST.advanceChildToEnd();
			program_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_0);
		}
		returnAST = program_AST;
	}
	
	public final void selection_stmt() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST selection_stmt_AST = null;
		
		try {      // for error handling
			AST tmp12_AST = null;
			tmp12_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp12_AST);
			match(LITERAL_if);
			match(LPAREN);
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			match(RPAREN);
			statement();
			astFactory.addASTChild(currentAST, returnAST);
			{
			if ((LA(1)==LITERAL_else) && (_tokenSet_1.member(LA(2)))) {
				match(LITERAL_else);
				statement();
				astFactory.addASTChild(currentAST, returnAST);
			}
			else if ((_tokenSet_2.member(LA(1))) && (_tokenSet_4.member(LA(2)))) {
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
			}
			selection_stmt_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_2);
		}
		returnAST = selection_stmt_AST;
	}
	
	public final void expression_stmt() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST expression_stmt_AST = null;
		
		try {      // for error handling
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			match(SEMI);
			expression_stmt_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_2);
		}
		returnAST = expression_stmt_AST;
	}
	
	public final void iteration_stmt() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST iteration_stmt_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LITERAL_while:
			{
				while_stmt();
				astFactory.addASTChild(currentAST, returnAST);
				iteration_stmt_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_for:
			{
				for_stmt();
				astFactory.addASTChild(currentAST, returnAST);
				iteration_stmt_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_2);
		}
		returnAST = iteration_stmt_AST;
	}
	
	public final void keyword_stmt() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST keyword_stmt_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LITERAL_pendown:
			case LITERAL_pd:
			{
				pendown_stmt();
				astFactory.addASTChild(currentAST, returnAST);
				keyword_stmt_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_penup:
			case LITERAL_pu:
			{
				penup_stmt();
				astFactory.addASTChild(currentAST, returnAST);
				keyword_stmt_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_home:
			{
				home_stmt();
				astFactory.addASTChild(currentAST, returnAST);
				keyword_stmt_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_forward:
			case LITERAL_fw:
			{
				forward_stmt();
				astFactory.addASTChild(currentAST, returnAST);
				keyword_stmt_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_backward:
			case LITERAL_bw:
			{
				backward_stmt();
				astFactory.addASTChild(currentAST, returnAST);
				keyword_stmt_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_left:
			case LITERAL_lf:
			{
				left_stmt();
				astFactory.addASTChild(currentAST, returnAST);
				keyword_stmt_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_right:
			case LITERAL_rt:
			{
				right_stmt();
				astFactory.addASTChild(currentAST, returnAST);
				keyword_stmt_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_clear:
			case LITERAL_cl:
			{
				clear_stmt();
				astFactory.addASTChild(currentAST, returnAST);
				keyword_stmt_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_break:
			{
				break_stmt();
				astFactory.addASTChild(currentAST, returnAST);
				keyword_stmt_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_continue:
			{
				continue_stmt();
				astFactory.addASTChild(currentAST, returnAST);
				keyword_stmt_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_return:
			{
				return_stmt();
				astFactory.addASTChild(currentAST, returnAST);
				keyword_stmt_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_echo:
			{
				echo_stmt();
				astFactory.addASTChild(currentAST, returnAST);
				keyword_stmt_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_status:
			{
				status_stmt();
				astFactory.addASTChild(currentAST, returnAST);
				keyword_stmt_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_2);
		}
		returnAST = keyword_stmt_AST;
	}
	
	public final void expression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST expression_AST = null;
		
		try {      // for error handling
			if ((_tokenSet_5.member(LA(1))) && (_tokenSet_6.member(LA(2)))) {
				operative_expr();
				astFactory.addASTChild(currentAST, returnAST);
				expression_AST = (AST)currentAST.root;
			}
			else if ((LA(1)==LITERAL_void||LA(1)==LITERAL_var)) {
				variable_decl_expr();
				astFactory.addASTChild(currentAST, returnAST);
				expression_AST = (AST)currentAST.root;
			}
			else if ((LA(1)==ID) && (LA(2)==ASSIGN)) {
				assignment_expr();
				astFactory.addASTChild(currentAST, returnAST);
				expression_AST = (AST)currentAST.root;
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_7);
		}
		returnAST = expression_AST;
	}
	
	public final void while_stmt() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST while_stmt_AST = null;
		
		try {      // for error handling
			AST tmp17_AST = null;
			tmp17_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp17_AST);
			match(LITERAL_while);
			match(LPAREN);
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			match(RPAREN);
			statement();
			astFactory.addASTChild(currentAST, returnAST);
			while_stmt_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_2);
		}
		returnAST = while_stmt_AST;
	}
	
	public final void for_stmt() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST for_stmt_AST = null;
		
		try {      // for error handling
			AST tmp20_AST = null;
			tmp20_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp20_AST);
			match(LITERAL_for);
			match(LPAREN);
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			match(SEMI);
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			match(SEMI);
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			match(RPAREN);
			statement();
			astFactory.addASTChild(currentAST, returnAST);
			for_stmt_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_2);
		}
		returnAST = for_stmt_AST;
	}
	
	public final void pendown_stmt() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST pendown_stmt_AST = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case LITERAL_pendown:
			{
				AST tmp25_AST = null;
				tmp25_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp25_AST);
				match(LITERAL_pendown);
				break;
			}
			case LITERAL_pd:
			{
				AST tmp26_AST = null;
				tmp26_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp26_AST);
				match(LITERAL_pd);
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(SEMI);
			pendown_stmt_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_2);
		}
		returnAST = pendown_stmt_AST;
	}
	
	public final void penup_stmt() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST penup_stmt_AST = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case LITERAL_penup:
			{
				AST tmp28_AST = null;
				tmp28_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp28_AST);
				match(LITERAL_penup);
				break;
			}
			case LITERAL_pu:
			{
				AST tmp29_AST = null;
				tmp29_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp29_AST);
				match(LITERAL_pu);
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(SEMI);
			penup_stmt_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_2);
		}
		returnAST = penup_stmt_AST;
	}
	
	public final void home_stmt() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST home_stmt_AST = null;
		
		try {      // for error handling
			{
			AST tmp31_AST = null;
			tmp31_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp31_AST);
			match(LITERAL_home);
			}
			match(SEMI);
			home_stmt_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_2);
		}
		returnAST = home_stmt_AST;
	}
	
	public final void forward_stmt() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST forward_stmt_AST = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case LITERAL_forward:
			{
				AST tmp33_AST = null;
				tmp33_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp33_AST);
				match(LITERAL_forward);
				break;
			}
			case LITERAL_fw:
			{
				AST tmp34_AST = null;
				tmp34_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp34_AST);
				match(LITERAL_fw);
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			match(SEMI);
			forward_stmt_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_2);
		}
		returnAST = forward_stmt_AST;
	}
	
	public final void backward_stmt() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST backward_stmt_AST = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case LITERAL_backward:
			{
				AST tmp36_AST = null;
				tmp36_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp36_AST);
				match(LITERAL_backward);
				break;
			}
			case LITERAL_bw:
			{
				AST tmp37_AST = null;
				tmp37_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp37_AST);
				match(LITERAL_bw);
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			match(SEMI);
			backward_stmt_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_2);
		}
		returnAST = backward_stmt_AST;
	}
	
	public final void left_stmt() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST left_stmt_AST = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case LITERAL_left:
			{
				AST tmp39_AST = null;
				tmp39_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp39_AST);
				match(LITERAL_left);
				break;
			}
			case LITERAL_lf:
			{
				AST tmp40_AST = null;
				tmp40_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp40_AST);
				match(LITERAL_lf);
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			match(SEMI);
			left_stmt_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_2);
		}
		returnAST = left_stmt_AST;
	}
	
	public final void right_stmt() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST right_stmt_AST = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case LITERAL_right:
			{
				AST tmp42_AST = null;
				tmp42_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp42_AST);
				match(LITERAL_right);
				break;
			}
			case LITERAL_rt:
			{
				AST tmp43_AST = null;
				tmp43_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp43_AST);
				match(LITERAL_rt);
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			match(SEMI);
			right_stmt_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_2);
		}
		returnAST = right_stmt_AST;
	}
	
	public final void clear_stmt() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST clear_stmt_AST = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case LITERAL_clear:
			{
				AST tmp45_AST = null;
				tmp45_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp45_AST);
				match(LITERAL_clear);
				break;
			}
			case LITERAL_cl:
			{
				AST tmp46_AST = null;
				tmp46_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp46_AST);
				match(LITERAL_cl);
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(SEMI);
			clear_stmt_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_2);
		}
		returnAST = clear_stmt_AST;
	}
	
	public final void break_stmt() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST break_stmt_AST = null;
		
		try {      // for error handling
			AST tmp48_AST = null;
			tmp48_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp48_AST);
			match(LITERAL_break);
			match(SEMI);
			break_stmt_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_2);
		}
		returnAST = break_stmt_AST;
	}
	
	public final void continue_stmt() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST continue_stmt_AST = null;
		
		try {      // for error handling
			AST tmp50_AST = null;
			tmp50_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp50_AST);
			match(LITERAL_continue);
			match(SEMI);
			continue_stmt_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_2);
		}
		returnAST = continue_stmt_AST;
	}
	
	public final void return_stmt() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST return_stmt_AST = null;
		
		try {      // for error handling
			AST tmp52_AST = null;
			tmp52_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp52_AST);
			match(LITERAL_return);
			{
			switch ( LA(1)) {
			case LPAREN:
			case ID:
			case DECIMAL:
			case LITERAL_void:
			case LITERAL_true:
			case LITERAL_false:
			case LITERAL_var:
			{
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case SEMI:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(SEMI);
			return_stmt_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_2);
		}
		returnAST = return_stmt_AST;
	}
	
	public final void echo_stmt() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST echo_stmt_AST = null;
		
		try {      // for error handling
			{
			AST tmp54_AST = null;
			tmp54_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp54_AST);
			match(LITERAL_echo);
			}
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			match(SEMI);
			echo_stmt_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_2);
		}
		returnAST = echo_stmt_AST;
	}
	
	public final void status_stmt() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST status_stmt_AST = null;
		
		try {      // for error handling
			{
			AST tmp56_AST = null;
			tmp56_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp56_AST);
			match(LITERAL_status);
			}
			match(SEMI);
			status_stmt_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_2);
		}
		returnAST = status_stmt_AST;
	}
	
	public final void type_specifier() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST type_specifier_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LITERAL_decimal:
			{
				AST tmp58_AST = null;
				tmp58_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp58_AST);
				match(LITERAL_decimal);
				type_specifier_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_boolean:
			{
				AST tmp59_AST = null;
				tmp59_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp59_AST);
				match(LITERAL_boolean);
				type_specifier_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_8);
		}
		returnAST = type_specifier_AST;
	}
	
	public final void return_type_specifier() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST return_type_specifier_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LITERAL_decimal:
			case LITERAL_boolean:
			{
				type_specifier();
				astFactory.addASTChild(currentAST, returnAST);
				return_type_specifier_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_void:
			{
				AST tmp60_AST = null;
				tmp60_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp60_AST);
				match(LITERAL_void);
				return_type_specifier_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_0);
		}
		returnAST = return_type_specifier_AST;
	}
	
	public final void params_list() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST params_list_AST = null;
		
		try {      // for error handling
			param();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop92:
			do {
				if ((LA(1)==COMMA)) {
					match(COMMA);
					param();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop92;
				}
				
			} while (true);
			}
			params_list_AST = (AST)currentAST.root;
			params_list_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(PARAMS_LIST,"PARAMS_LIST")).add(params_list_AST));
			currentAST.root = params_list_AST;
			currentAST.child = params_list_AST!=null &&params_list_AST.getFirstChild()!=null ?
				params_list_AST.getFirstChild() : params_list_AST;
			currentAST.advanceChildToEnd();
			params_list_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_9);
		}
		returnAST = params_list_AST;
	}
	
	public final void func_body() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST func_body_AST = null;
		
		try {      // for error handling
			match(LBRACE);
			{
			_loop89:
			do {
				if ((_tokenSet_1.member(LA(1)))) {
					statement();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop89;
				}
				
			} while (true);
			}
			match(RBRACE);
			func_body_AST = (AST)currentAST.root;
			func_body_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(STATEMENT,"FUNC_BODY")).add(func_body_AST));
			currentAST.root = func_body_AST;
			currentAST.child = func_body_AST!=null &&func_body_AST.getFirstChild()!=null ?
				func_body_AST.getFirstChild() : func_body_AST;
			currentAST.advanceChildToEnd();
			func_body_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_3);
		}
		returnAST = func_body_AST;
	}
	
	public final void param() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST param_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LITERAL_decimal:
			case LITERAL_boolean:
			{
				type_specifier();
				astFactory.addASTChild(currentAST, returnAST);
				AST tmp64_AST = null;
				tmp64_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp64_AST);
				match(ID);
				param_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_void:
			{
				AST tmp65_AST = null;
				tmp65_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp65_AST);
				match(LITERAL_void);
				param_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_10);
		}
		returnAST = param_AST;
	}
	
	public final void operative_expr() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST operative_expr_AST = null;
		
		try {      // for error handling
			logical_expr();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop106:
			do {
				if ((LA(1)==OR)) {
					AST tmp66_AST = null;
					tmp66_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp66_AST);
					match(OR);
					logical_expr();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop106;
				}
				
			} while (true);
			}
			operative_expr_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_7);
		}
		returnAST = operative_expr_AST;
	}
	
	public final void variable_decl_expr() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST variable_decl_expr_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LITERAL_var:
			{
				AST tmp67_AST = null;
				tmp67_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp67_AST);
				match(LITERAL_var);
				type_specifier();
				astFactory.addASTChild(currentAST, returnAST);
				AST tmp68_AST = null;
				tmp68_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp68_AST);
				match(ID);
				{
				switch ( LA(1)) {
				case ASSIGN:
				{
					AST tmp69_AST = null;
					tmp69_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp69_AST);
					match(ASSIGN);
					expression();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case RPAREN:
				case SEMI:
				case COMMA:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				variable_decl_expr_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_void:
			{
				AST tmp70_AST = null;
				tmp70_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp70_AST);
				match(LITERAL_void);
				variable_decl_expr_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_7);
		}
		returnAST = variable_decl_expr_AST;
	}
	
	public final void assignment_expr() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST assignment_expr_AST = null;
		
		try {      // for error handling
			lvalue();
			astFactory.addASTChild(currentAST, returnAST);
			AST tmp71_AST = null;
			tmp71_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp71_AST);
			match(ASSIGN);
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			assignment_expr_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_7);
		}
		returnAST = assignment_expr_AST;
	}
	
	public final void primary_expr() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST primary_expr_AST = null;
		
		try {      // for error handling
			if ((LA(1)==ID) && (_tokenSet_11.member(LA(2)))) {
				AST tmp72_AST = null;
				tmp72_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp72_AST);
				match(ID);
				primary_expr_AST = (AST)currentAST.root;
			}
			else if ((LA(1)==DECIMAL||LA(1)==LITERAL_true||LA(1)==LITERAL_false)) {
				constant_expr();
				astFactory.addASTChild(currentAST, returnAST);
				primary_expr_AST = (AST)currentAST.root;
			}
			else if ((LA(1)==ID) && (LA(2)==LPAREN)) {
				func_call_expr();
				astFactory.addASTChild(currentAST, returnAST);
				primary_expr_AST = (AST)currentAST.root;
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_11);
		}
		returnAST = primary_expr_AST;
	}
	
	public final void constant_expr() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST constant_expr_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LITERAL_true:
			{
				AST tmp73_AST = null;
				tmp73_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp73_AST);
				match(LITERAL_true);
				constant_expr_AST = (AST)currentAST.root;
				break;
			}
			case LITERAL_false:
			{
				AST tmp74_AST = null;
				tmp74_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp74_AST);
				match(LITERAL_false);
				constant_expr_AST = (AST)currentAST.root;
				break;
			}
			case DECIMAL:
			{
				AST tmp75_AST = null;
				tmp75_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp75_AST);
				match(DECIMAL);
				constant_expr_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_11);
		}
		returnAST = constant_expr_AST;
	}
	
	public final void func_call_expr() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST func_call_expr_AST = null;
		
		try {      // for error handling
			AST tmp76_AST = null;
			tmp76_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp76_AST);
			match(ID);
			match(LPAREN);
			expr_list();
			astFactory.addASTChild(currentAST, returnAST);
			match(RPAREN);
			func_call_expr_AST = (AST)currentAST.root;
			func_call_expr_AST=(AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(FUNC_CALL,"FUNC_CALL")).add(func_call_expr_AST));
			currentAST.root = func_call_expr_AST;
			currentAST.child = func_call_expr_AST!=null &&func_call_expr_AST.getFirstChild()!=null ?
				func_call_expr_AST.getFirstChild() : func_call_expr_AST;
			currentAST.advanceChildToEnd();
			func_call_expr_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_11);
		}
		returnAST = func_call_expr_AST;
	}
	
	public final void expr_list() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST expr_list_AST = null;
		
		try {      // for error handling
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop100:
			do {
				if ((LA(1)==COMMA)) {
					match(COMMA);
					expression();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop100;
				}
				
			} while (true);
			}
			expr_list_AST = (AST)currentAST.root;
			expr_list_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(EXPR_LIST,"EXPR_LIST")).add(expr_list_AST));
			currentAST.root = expr_list_AST;
			currentAST.child = expr_list_AST!=null &&expr_list_AST.getFirstChild()!=null ?
				expr_list_AST.getFirstChild() : expr_list_AST;
			currentAST.advanceChildToEnd();
			expr_list_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_9);
		}
		returnAST = expr_list_AST;
	}
	
	public final void lvalue() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST lvalue_AST = null;
		
		try {      // for error handling
			AST tmp80_AST = null;
			tmp80_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp80_AST);
			match(ID);
			lvalue_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_12);
		}
		returnAST = lvalue_AST;
	}
	
	public final void logical_expr() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST logical_expr_AST = null;
		
		try {      // for error handling
			relational_expr();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop109:
			do {
				if ((LA(1)==AND)) {
					AST tmp81_AST = null;
					tmp81_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp81_AST);
					match(AND);
					relational_expr();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop109;
				}
				
			} while (true);
			}
			logical_expr_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_13);
		}
		returnAST = logical_expr_AST;
	}
	
	public final void relational_expr() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST relational_expr_AST = null;
		
		try {      // for error handling
			additive_expr();
			astFactory.addASTChild(currentAST, returnAST);
			{
			switch ( LA(1)) {
			case EQ:
			case NEQ:
			case GT:
			case GE:
			case LT:
			case LE:
			{
				{
				switch ( LA(1)) {
				case LT:
				{
					AST tmp82_AST = null;
					tmp82_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp82_AST);
					match(LT);
					break;
				}
				case LE:
				{
					AST tmp83_AST = null;
					tmp83_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp83_AST);
					match(LE);
					break;
				}
				case GT:
				{
					AST tmp84_AST = null;
					tmp84_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp84_AST);
					match(GT);
					break;
				}
				case GE:
				{
					AST tmp85_AST = null;
					tmp85_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp85_AST);
					match(GE);
					break;
				}
				case EQ:
				{
					AST tmp86_AST = null;
					tmp86_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp86_AST);
					match(EQ);
					break;
				}
				case NEQ:
				{
					AST tmp87_AST = null;
					tmp87_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp87_AST);
					match(NEQ);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				additive_expr();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case RPAREN:
			case SEMI:
			case COMMA:
			case AND:
			case OR:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			relational_expr_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_14);
		}
		returnAST = relational_expr_AST;
	}
	
	public final void additive_expr() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST additive_expr_AST = null;
		
		try {      // for error handling
			multiplicative_expr();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop116:
			do {
				if ((LA(1)==PLUS||LA(1)==MINUS)) {
					{
					switch ( LA(1)) {
					case PLUS:
					{
						AST tmp88_AST = null;
						tmp88_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp88_AST);
						match(PLUS);
						break;
					}
					case MINUS:
					{
						AST tmp89_AST = null;
						tmp89_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp89_AST);
						match(MINUS);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					multiplicative_expr();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop116;
				}
				
			} while (true);
			}
			additive_expr_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_15);
		}
		returnAST = additive_expr_AST;
	}
	
	public final void multiplicative_expr() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST multiplicative_expr_AST = null;
		
		try {      // for error handling
			rvalue();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop120:
			do {
				if (((LA(1) >= MULT && LA(1) <= MOD))) {
					{
					switch ( LA(1)) {
					case MULT:
					{
						AST tmp90_AST = null;
						tmp90_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp90_AST);
						match(MULT);
						break;
					}
					case DIV:
					{
						AST tmp91_AST = null;
						tmp91_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp91_AST);
						match(DIV);
						break;
					}
					case MOD:
					{
						AST tmp92_AST = null;
						tmp92_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp92_AST);
						match(MOD);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					rvalue();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop120;
				}
				
			} while (true);
			}
			multiplicative_expr_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_16);
		}
		returnAST = multiplicative_expr_AST;
	}
	
	public final void rvalue() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST rvalue_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case ID:
			case DECIMAL:
			case LITERAL_true:
			case LITERAL_false:
			{
				primary_expr();
				astFactory.addASTChild(currentAST, returnAST);
				rvalue_AST = (AST)currentAST.root;
				break;
			}
			case LPAREN:
			{
				match(LPAREN);
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				match(RPAREN);
				rvalue_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_11);
		}
		returnAST = rvalue_AST;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"ALPHA",
		"DIGIT",
		"WS",
		"EOL",
		"COMMENT",
		"LPAREN",
		"RPAREN",
		"MULT",
		"DIV",
		"MOD",
		"PLUS",
		"MINUS",
		"SEMI",
		"LBRACE",
		"RBRACE",
		"ASSIGN",
		"COMMA",
		"EQ",
		"NEQ",
		"GT",
		"GE",
		"LT",
		"LE",
		"AND",
		"OR",
		"ID",
		"DECIMAL",
		"STATEMENT",
		"FUNC_CALL",
		"EXPR_LIST",
		"PARAMS_LIST",
		"FUNC_BODY",
		"\"exit\"",
		"\"bye\"",
		"\"quit\"",
		"\"if\"",
		"\"else\"",
		"\"while\"",
		"\"for\"",
		"\"break\"",
		"\"continue\"",
		"\"return\"",
		"\"pendown\"",
		"\"pd\"",
		"\"penup\"",
		"\"pu\"",
		"\"home\"",
		"\"forward\"",
		"\"fw\"",
		"\"backward\"",
		"\"bw\"",
		"\"right\"",
		"\"rt\"",
		"\"left\"",
		"\"lf\"",
		"\"echo\"",
		"\"clear\"",
		"\"cl\"",
		"\"status\"",
		"\"decimal\"",
		"\"boolean\"",
		"\"void\"",
		"\"funct\"",
		"\"true\"",
		"\"false\"",
		"\"var\""
	};
	
	protected void buildTokenTypeASTClassMap() {
		tokenTypeToASTClassMap=null;
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 2L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = { 9223370389198078464L, 58L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = { 9223371488709968386L, 62L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	private static final long[] mk_tokenSet_3() {
		long[] data = { 9223370389198078466L, 62L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_3 = new BitSet(mk_tokenSet_3());
	private static final long[] mk_tokenSet_4() {
		long[] data = { -547609380350L, 63L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_4 = new BitSet(mk_tokenSet_4());
	private static final long[] mk_tokenSet_5() {
		long[] data = { 1610613248L, 24L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_5 = new BitSet(mk_tokenSet_5());
	private static final long[] mk_tokenSet_6() {
		long[] data = { 2146565632L, 58L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_6 = new BitSet(mk_tokenSet_6());
	private static final long[] mk_tokenSet_7() {
		long[] data = { 1115136L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_7 = new BitSet(mk_tokenSet_7());
	private static final long[] mk_tokenSet_8() {
		long[] data = { 536870914L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_8 = new BitSet(mk_tokenSet_8());
	private static final long[] mk_tokenSet_9() {
		long[] data = { 1024L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_9 = new BitSet(mk_tokenSet_9());
	private static final long[] mk_tokenSet_10() {
		long[] data = { 1049600L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_10 = new BitSet(mk_tokenSet_10());
	private static final long[] mk_tokenSet_11() {
		long[] data = { 535952384L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_11 = new BitSet(mk_tokenSet_11());
	private static final long[] mk_tokenSet_12() {
		long[] data = { 524288L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_12 = new BitSet(mk_tokenSet_12());
	private static final long[] mk_tokenSet_13() {
		long[] data = { 269550592L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_13 = new BitSet(mk_tokenSet_13());
	private static final long[] mk_tokenSet_14() {
		long[] data = { 403768320L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_14 = new BitSet(mk_tokenSet_14());
	private static final long[] mk_tokenSet_15() {
		long[] data = { 535888896L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_15 = new BitSet(mk_tokenSet_15());
	private static final long[] mk_tokenSet_16() {
		long[] data = { 535938048L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_16 = new BitSet(mk_tokenSet_16());
	
	}
